#line 1 "C:/FILES/pic/mikro projects/digitalclock.c"

sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;

sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;


volatile int

change=0,
count=0,
sec=0,
minu=0,
hr=0;

 void delay_ms(int ms)
 {
 int i;
 for(i = ms; i > 0; i--) delay_ms(1);
 }
 void timer_init()
 {
 TMR1H=TMR1L=0;
 T1CON.T1CKPS1=1;
 T1CON.T1CKPS0=0;
 T1CON.T1OSCEN=0;
 T1CON.TMR1CS=0;
 PIE1.TMR1IE=1;
 T1CON.TMR1ON=1;
 INTCON.PEIE=1;
 INTCON.GIE=1;
 }

 void Interrupt_ISR()
{
 if(PIR1.TMR1IF==1)
 {
 count++;
 PIR1.TMR1IF=0;
 }
 }

 void displayclock()
 {


 if(hr<10)
 {
 LCD_out(1,5,"0");
 _LCD_MOVE_CURSOR_RIGHT;
 Lcd_Out(1,6,hr);
 _LCD_MOVE_CURSOR_RIGHT;
 }
 else
 {
 LCD_out(1,5,hr);
 _LCD_MOVE_CURSOR_RIGHT;
 }
 LCD_out(1,7,":");
 _LCD_MOVE_CURSOR_RIGHT;

 if(minu<10)
 {
 LCD_out(1,8,"0");
 _LCD_MOVE_CURSOR_RIGHT;
 Lcd_Out(1,9,minu);
 _LCD_MOVE_CURSOR_RIGHT;
 }
 else
 {
 LCD_out(1,8,minu);
 _LCD_MOVE_CURSOR_RIGHT;
 }
 LCD_out(1,10,":");
 _LCD_MOVE_CURSOR_RIGHT;

 if(sec<10)
 {
 LCD_out(1,11,"0");
 _LCD_MOVE_CURSOR_RIGHT;
 Lcd_Out(1,12,sec);
 _LCD_MOVE_CURSOR_RIGHT;
 }
 else
 {
 LCD_out(1,11,sec);
 _LCD_MOVE_CURSOR_RIGHT;
 }
 }
 int main()
 {
 LCD_init();

 hr=18;
 minu=34;
 sec=10;

 timer_init();
 displayclock();
 while(1)
 {
 if(count==19)
 {
 sec++;
 count=0;
 change=1;
 }
 if(sec==60)
 {
 minu++;
 sec=0;
 change=1;
 }
 if(minu==60)
 {
 hr++;
 minu=0;
 change=1;
 }
 if(hr==24)
 {
 hr=0;
 minu=0;
 sec=0;
 }

 if(change)
 {
 displayClock();
 change = 0;
 }
 }
 }
